#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>

int main() {
    char buf[11];
    int fd, pos;
    if ((fd = open("file", O_RDWR | O_CREAT | O_TRUNC, 0664)) < 0)
	perror("open"), exit(1);
    
    pos = lseek(fd, 0, SEEK_CUR);	/* Position ermitteln */
    printf("Position: %d\n", pos);

    if (write(fd, "0123456789\n", 11) != 11)	/* String schreiben */
	perror("write"), exit(2);
    
    pos = lseek(fd, 0, SEEK_CUR);	/* Position ermitteln */
    printf("Position: %d\n", pos);
    
    lseek(fd, 2, SEEK_SET);		/* 2 Bytes hinter den Anfang */
    
    if (write(fd, "xx", 2) != 2)		/* String schreiben */
	perror("write"), exit(2);
    
    pos = lseek(fd, 0, SEEK_CUR);	/* Position ermitteln */
    printf("Position: %d\n", pos);
    
    lseek(fd, -4, SEEK_END);		/* 4 Bytes vor das Ende */
    
    if (write(fd, "aa", 2) != 2)		/* String schreiben */
	perror("write"), exit(2);
    
    pos = lseek(fd, 0, SEEK_CUR);	/* Position ermitteln */
    printf("Position: %d\n", pos);

    lseek(fd, 0, SEEK_SET);	/* an den Anfang positionieren */
    read(fd, buf, 10);		/* 10 Zeichen lesen */
    buf[10] = '\0';		/* String mit Null-Byte terminieren */
    puts(buf);			/* ... und schliesslich ausgeben */
    
    pos = lseek(fd, 0, SEEK_CUR);	/* Position ermitteln */
    printf("Position: %d\n", pos);

    return 0;    
}
